#!/usr/bin/env python
#
#   kFTP
#   Copyright (c) 2002, Kong Hyeog Jun <sanzio2001@hanmail.net>
#   
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
# 
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
# 
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 

from ftplib import FTP
import ftplib
import sys, cmd, string, os,socket,time

class Simple_FTP_Client(cmd.Cmd):
	def __init__(self):
		cmd.Cmd.__init__(self)
		self.prompt = "kFTP>"
		self.ftp = FTP()
		self.wdir =""
		print "Welcome SFC!"
		while 1:
			try :
				ServerName = raw_input("Enter Server Name:")
				print "connecting..."
				print "%s" % self.ftp.connect(ServerName)
			except socket.gaierror:
				print "Error : No address associated with Server Name"
				print "Again!"
			except:
				pass
			else:
				break
		# print "Connected to %s" % ServerName

		UserID = raw_input("Enter User ID:")
		if UserID == "": UserID = "anonymous"
		UserPW = raw_input("Enter User PW:")
		if UserPW == "": UserPW = "realuser@host"
		flag = 0
		
		while 1:
			if flag:
				UserID = raw_input("Enter User ID:")
				UserPW = raw_input("Enter User PW:")
				flag = 0
			if not flag:
				try:
					self.ftp.login(UserID,UserPW)
				except ftplib.error_perm:
					print "Error : User anonymous login failed."
					print "Again!"
					flag = 1
				else:
					break
				
		print "Login successful. Have fun!"

	#def do_literal(self,FSCmd):
	#	if FSCmd == "": FSCmd = raw_input("Enter FTP SERVICE COMMAND:")
	#	FSCmd = string.split(FSCmd," ")
	#	if FSCmd[0][1] == "v":
	#		self.ftp.voidcmd(FSCmd[1])
	#	elif FSCmd[0][1] == "s":
	#		while 1:
	#			tmp = self.ftp.sendcmd(FSCmd[1])
	#			if not tmp:
	#				break
	#			print tmp
	#		tmp = self.ftp.getresp()
	#		print tmp
			
	def ShowDir(self,strarg = None):
		try:
			tmp = self.ftp.sendcmd('PWD')
			tmp = string.split(tmp," ")
			print "Remote Current Directory is "+tmp[1]
		except:
			pass
	
	def do_get(self, tar):
		flag = 1
		if tar =="":
			flag = 0
		while 1:
			try:
				if not flag: tar = raw_input("Enter file name:")
				self.ftp.voidcmd("TYPE I")
				conn = self.ftp.transfercmd("RETR "+tar) 
				flen = 0
				f = file(tar,"w")
			except  :
				print "No such file or directory: ", tar
				flag = 0
			else:
				break
		while 1:
			block = conn.recv(8192)
			if len(block) == 0:
				break
			print "\r %d" % flen,
			flen = flen + len(block)
			f.write(block)
		print "\r Transferred ", flen, " bytes"
		conn.close()
		self.ftp.voidresp()
		
	def do_put(self,tar):
		flag = 1
		if tar =="":
		    flag = 0
		while 1:
			try:
				if not flag: tar = raw_input("Enter file name:")
				self.ftp.voidcmd("TYPE I")
				conn = self.ftp.transfercmd("STOR "+tar)
				flen = 0
				f = file(tar,"r")
			except:
				print "No such file or directory: ", tar
				flag = 0
			else :
				break
		
		while 1:
			block = f.read(8192)
			if len(block) == 0:
				break
			print "\r %d" % flen,
			flen = flen + len(block)
			conn.sendall(block)
		print "\r Transferred ", flen, " bytes"
		conn.close()
		self.ftp.voidresp()
		
	def do_ls(self,strarg = None):
		self.ftp.retrlines('LIST')
		self.ShowDir(self)
		
	def do_cd(self,tdir):
		if tdir=="":tdir=raw_input("Enter Dir:")
		self.ftp.cwd(tdir)
		self.ShowDir(self)

	def do_bye(self,strarg = None):
		self.ftp.quit()
		print "Bye!"
		sys.exit()
	
	def do_mkdir(self, dirname):
		if dirname=="":dirname = raw_input("Enter Directory Name:")
		self.ftp.mkd(dirname)
		print "MKDIR success!"
		self.ShowDir(self)
		
	def do_rmdir(self, dirname):
		if dirname=="":dirname = raw_input("Enter Directory Name:")
		self.ftp.rmd(dirname)
		print "RMDIR success!"
		self.ShowDir(self)
		
	def do_rm(self, filename):
		if filename=="":filename = raw_input("Enter File Name:")
		self.ftp.delete(filename)
		print "RM sucess!"
		self.ShowDir(self)
		
	def do_ren(self,file):
		files = string.split(file," ")
		self.ftp.rename(files[0],files[1])
		print "REN sucess!"
		self.ShowDir(self)
		
	def do_lcd(self, strarg = None):
		print "Locol Current Directory is "+ os.getcwd()
	
	def do_help(self,strarg = None):
		pass

if __name__ == "__main__":
	start = Simple_FTP_Client()
	start.cmdloop()

	
